import Entity from '../Entity.js';
import Vec2 from '../Vec2.js';

import KeyboardControls from '../traits/KeyboardControls.js';
import Physics from '../traits/Physics.js';

export default class Player extends Entity {
	constructor(level) {
		super(level);

		this.bounds.size.set(20, 20);
		this.addTrait(new KeyboardControls(this));
		this.addTrait(new Physics(this));
	}

	draw(ctx) {
		this.bounds.draw(ctx);
	}
}
