import Level from './Level';
import Player from './entities/Player';
import Vec2 from './Vec2';

let canvas = document.getElementById("canvas");

let level = new Level(canvas);

level.spawn(new Player(level), 20, 20);

level.start();

// Pause the game when the tab has been out of focus for more than half a second
let blurTimeout = null;
window.addEventListener("focus", () => {
	if (blurTimeout != null) {
		clearTimeout(blurTimeout);
		blurTimeout = null;
	}
	level.start();
});
window.addEventListener("blur", () => {
	if (blurTimeout == null) {
		blurTimeout = setTimeout(() => level.stop(), 500);
	}
});

// Resize canvas
function resize() {
	canvas.width = window.innerWidth;
	canvas.height = window.innerHeight;
}
window.addEventListener("resize", resize);
resize();
